<?php

namespace App\Classes\Frame;

use Illuminate\Support\Facades\Log;

use App\Classes\Frame;
use App\Classes\Parser;
use App\Classes\Parser\Videotex as VideotexParser;
use App\Models\Frame as FrameModel;

class Videotex extends Frame
{
	public static $frame_length = 22;
	public static $frame_width = 40;

	public static $header_length = 20;
	public static $pagenum_length = 9;
	public static $cost_length = 7;
	public static $cost_unit = 'u';

	public static $if_filler = '.';

	public function __construct(FrameModel $o,string $msg='')
	{
		parent::__construct($o);

		// If we have a message to display on the bottom line.
		if ($msg)
			$this->output .= HOME.UP.$msg.HOME;
	}

	protected function parser(int $startline): Parser
	{
		return new VideotexParser($this->fo->content,self::$frame_width,$startline);
	}

	public static function strlenv($text):int {
		return strlen($text)-substr_count($text,ESC);
	}
}